// APIFont.h: interface for the CAPIFont class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_APIFONT_H__4CA5DCFA_90AD_401C_B8AB_020F7A440216__INCLUDED_)
#define AFX_APIFONT_H__4CA5DCFA_90AD_401C_B8AB_020F7A440216__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "APITexture.h"

class CAPIFont  
{
public:
	CAPIFont();
	virtual ~CAPIFont();

private:
	CAPITexture *texture;	// Only a reference, APITextures holds the actual texture
	char filename[50];		// filename to load font from (NOT an MS file, custom binary instead)

	unsigned width;			// Dimensions the font in the binary file
	unsigned height;		//   (total width and height of pixel data)
							//   This is NOT the dimensions of the texture

	bool charValid[256];	// Is character valid to render?
	BYTE charWidth[256];	// Width of character
	BYTE *charData;			// Actual binary data for font (not texture compatible)

	float charStartS[256];	// Starting point in texture for character
	float charStartT[256];
	bool valid;				// Was the binary data successfully loaded?

public:
	void Initialize(char *p_filename);
	void Destroy(void);
	CAPITexture * GetTexture(void) {return texture;}

	bool * GetCharValid(void) {return &charValid[0];}
	BYTE * GetCharWidth(void) {return &charWidth[0];}
	BYTE * GetCharData(void) {return &charData[0];}
	float * GetCharStartS(void) {return charStartS;}
	float * GetCharStartT(void) {return charStartT;}

	bool IsValid() {return valid;}

	void SetCharStartS(unsigned p_id, float p_s) {charStartS[p_id] = p_s;}
	void SetCharStartT(unsigned p_id, float p_t) {charStartT[p_id] = p_t;}

	unsigned GetWidth(void) {return width;}
	unsigned GetHeight(void) {return height;}

	void GetTextDimensions (char *p_text, unsigned &p_widthOut, unsigned &p_heightOut);
	unsigned GetTextWidth (char *p_text);
};

#endif // !defined(AFX_APIFONT_H__4CA5DCFA_90AD_401C_B8AB_020F7A440216__INCLUDED_)
