// ColorRGB.cpp: implementation of the CColorRGB class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ColorRGB.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CColorRGB::CColorRGB()
{
	red = 255;
	green = 255;
	blue = 255;
}

CColorRGB::CColorRGB(BYTE p_red, BYTE p_green, BYTE p_blue)
{
	red = p_red;
	green = p_green;
	blue = p_blue;
}

CColorRGB::~CColorRGB()
{

}

CColorRGB CColorRGB::Modulate(CColorRGB p_color)
{
	if (p_color.IsWhite())
		return *this;
	else
	{
		CColorRGB out;

		out.red = (red * p_color.red) / 255;
		out.green = (green * p_color.green) / 255;
		out.blue = (blue * p_color.blue) / 255;

		return out;
	}
}

CColorRGB CColorRGB::Scm(float p_mod)
{
	CColorRGB out;
	int red1, green1, blue1;

	red1 = int(red * p_mod);
	green1 = int(green * p_mod);
	blue1 = int(blue * p_mod);

	if (red1<0) red1=0;
	if (green1<0) green1=0;
	if (blue1<0) blue1=0;
	if (red1>255) red1=255;
	if (green1>255) green1=255;
	if (blue1>255) blue1=255;

	out.red = red1;
	out.green = green1;
	out.blue = blue1;

	return out;
}

CColorRGB CColorRGB::AddTend(CColorRGB p_color)
{
    // Color gradually moves to full, but the closer it gets,
    //   the harder it is to change
	// Simulates a blend of one minus dest color
    CColorRGB out;
	int r1, g1, b1;
    r1 = BYTE(red + p_color.red * float(255-red) / 255.0f);
    g1 = BYTE(green + p_color.green * float(255-green) / 255.0f);
    b1 = BYTE(blue + p_color.blue * float(255-blue) / 255.0f);
    if (r1 > 255) r1 = 255;
    if (g1 > 255) g1 = 255;
    if (b1 > 255) b1 = 255;
    out.red = r1;
    out.green = g1;
    out.blue = b1;

	return out;
}

