// Model3D.h: interface for the CModel3D class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MODEL3D_H__E32755DF_7C8F_49F8_ACB5_057D026EF0C0__INCLUDED_)
#define AFX_MODEL3D_H__E32755DF_7C8F_49F8_ACB5_057D026EF0C0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ModelVertex3D.h"
#include "Surface3D.h"

class CModel3D  
{
public:
	CModel3D();
	virtual ~CModel3D();

private:
	unsigned vertexQty;
	CModelVertex3D	*vertices;

	unsigned surfaceQty;
	CSurface3D *surfaces;

	float radius;		//  Outer bound of used vertices

public:
	unsigned GetVertexQty() {return vertexQty;}
	CModelVertex3D * GetVertices() {return vertices;}
	CModelVertex3D & GetVertex(unsigned p_id) {return vertices[p_id];}

	unsigned GetSurfaceQty() {return surfaceQty;}
	CSurface3D * GetSurfaces() {return surfaces;}

	CSurface3D & GetSurface(unsigned p_id) {return surfaces[p_id];}

	inline float GetRadius(void) {return radius;}

	void Initialize(unsigned p_vertexQty, unsigned p_surfaceQty)
	{
		Initialize(p_vertexQty, p_surfaceQty, true);
	}
	void Initialize(unsigned p_vertexQty, unsigned p_surfaceQty, bool p_allSurfacesWhite);

	void MakeTestBlock(void);
	inline void MakeBlock(float p_minX, float p_minY, float p_minZ, float p_maxX, float p_maxY, float p_maxZ)
	{
		MakeBlock(p_minX, p_minY, p_minZ, p_maxX, p_maxY, p_maxZ, NULL);
	}
	void MakeBlock(float p_minX, float p_minY, float p_minZ, float p_maxX, float p_maxY, float p_maxZ, CAPITexture *p_texture);
	void GenerateSphere2(float p_radius);
	void GenerateSphere2(float p_radius, CColorRGB *p_color);

	void CalculateSurfaceData(void);

	void Destroy(void);
};

#endif // !defined(AFX_MODEL3D_H__E32755DF_7C8F_49F8_ACB5_057D026EF0C0__INCLUDED_)
