// RenderObject.h: interface for the CRenderObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RENDEROBJECT_H__80E6BD10_591C_47C4_BC64_A02F536FCB8F__INCLUDED_)
#define AFX_RENDEROBJECT_H__80E6BD10_591C_47C4_BC64_A02F536FCB8F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\math\Orient3D.h"
#include "Model3D.h"
#include "..\structs\octree.h"

// This is simply a partial reference to a world game object, 
//    enough only to render it
class CRenderObject  
{
public:
	CRenderObject();
	virtual ~CRenderObject();

	COrient3D	orient;
	CModel3D *modelRef;	// Only a reference, no need to destroy
	CVector3D scalef;
	unsigned int renderID;

	bool controlObject;	// Should this object only be rendered in mirrors?

	// Octree cells this object is touching
	COctCellRefList cellsTouched;
	void DetermineCellsTouched(COctree &p_octree);
};

class CRenderObjectList: public CLinkedList<CRenderObject>
{
public:
	void Delete(CLinkedListNode<CRenderObject> *node)
	{
		node->cellsTouched.EmptyList();
		CLinkedList<CRenderObject>::Delete(node);
	}

	void EmptyList(void)
	{
		CLinkedListNode<CRenderObject> *node = GetFirst();
		if (node)
		while (node->next != NULL)
		{
			node->cellsTouched.EmptyList();

			node = node->next;
		}
		CLinkedList<CRenderObject>::EmptyList();
	}
};

#endif // !defined(AFX_RENDEROBJECT_H__80E6BD10_591C_47C4_BC64_A02F536FCB8F__INCLUDED_)
