// StarField.cpp: implementation of the CStarField class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "StarField.h"
#include <stdio.h>	// rand(), srand()
#include <mmsystem.h> // timeGetTime

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStarField::CStarField()
{

}

CStarField::~CStarField()
{
	Destroy();
}

void CStarField::Destroy(void)
{
	if (stars)
		delete [] stars;
	stars = NULL;
	starQty = 0;
}

void CStarField::Initialize(unsigned p_starQty, bool p_hemisphere)
{
	if (p_starQty > 0)
	{
		starQty = p_starQty;
		stars = new strStar[starQty];

		srand(timeGetTime());

		unsigned i;
		CVector3D v1;

		for (i=0; i<starQty; i=i)
		{
			// Get a random point, discard anything outside the sphere
			//   so we get a uniform result
			v1.SetVec(2.0f * float(rand())/float(RAND_MAX) - 1.0f, 2.0f * float(rand())/float(RAND_MAX) - 1.0f, 2.0f * float(rand())/float(RAND_MAX) - 1.0f);
			//v1.SetVec(0.5f, 0.1f, 0.0f);
			if ((v1.MgnTudSqr() <= 1.0f) && ((!p_hemisphere)||(v1.y > 0.0f)))
			{
				if (v1.Unitize())
				{	
					stars[i].pos = v1;
					stars[i].color.SetColor(255,255,255);
					//stars[i].intensity = BYTE((float(rand())/float(RAND_MAX)*0.5f + 0.5f)*255);
					stars[i].intensity = BYTE((float(rand())/float(RAND_MAX))*255);
					//stars[i].radius = 0.5f + float(rand())/float(RAND_MAX) * 2.0f;

					i++;
				}
			}
		}
	}
}