// SurfaceDecal.cpp: implementation of the CSurfaceDecal class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SurfaceDecal.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLinkedList<CSurfaceDecal> CLinkedList<CSurfaceDecal>::DeletedList;

CSurfaceDecal::CSurfaceDecal()
{
	backside = false;
	vertices = NULL;
	vertexQty = 0;
}

CSurfaceDecal::~CSurfaceDecal()
{
	Destroy();
}

void CSurfaceDecal::Destroy(void)
{
	surface.Destroy();
	if (vertices)
	{
		delete [] vertices;
		vertices = NULL;
		vertexQty = 0;
	}
}

CSurfaceDecalList::~CSurfaceDecalList()
{
	TRACE("Destroying a decal list\n");

	DestroyDecals();
	//EmptyList();	// Doesn't appear we need this either

	// Wipe out the nodes now
	// ?? Do we need this?
	//CLinkedList<CSurfaceDecal>::~CLinkedList();
}

void CSurfaceDecalList::DestroyDecals(void)
{
	// Wipe out all the data from the nodes
	CLinkedListNode<CSurfaceDecal> *node;
	node = GetFirst();
	if (node)
		while (node->next != NULL)
		{
			node->Destroy();

			node = node->next;
		}
}
