#ifndef GLOBALS_H_LOADED
#define GLOBALS_H_LOADED

// NOTE: Using this library assumes your video card has at least 1 clip plane,
//    an 8-bit stencil buffer, 16-bit depth plane,
//    a 3-level texture pipeline (2 for GL), can 
//    render to an offscreen buffer, and support textures of 512x512

#include "api3d\apitextureregistry.h"
#include "api3d\IRender.h"
#include "api3d\OpenGLRender.h"
#include "metrics.h"

extern CAPITextureRegistry APITextures;
extern IRender *Render;
extern OpenGLRender OpenGL;

extern CMetrics Metrics;

const unsigned DYNAMICLIGHTMAPDIMENSION = 512;

bool SphereCollision(CSurface3D *p_surfaces, unsigned p_surfaceQty, CModelVertex3D *p_vertices, unsigned p_vertexQty, CVector3D &p_pos, CVector3D &p_offset, float p_radius, float &p_timeOut, CVector3D &p_normalOut, CSurface3D **p_collisionSurfaceOut, CLinkedList<CInteger> *p_vertexList);
inline bool SphereCollision(CSurface3D *p_surfaces, unsigned p_surfaceQty, CModelVertex3D *p_vertices, unsigned p_vertexQty, CVector3D &p_pos, CVector3D &p_offset, float p_radius, float &p_timeOut, CVector3D &p_normalOut, CSurface3D **p_collisionSurfaceOut)
{
	return SphereCollision(p_surfaces, p_surfaceQty, p_vertices, p_vertexQty, p_pos, p_offset, p_radius, p_timeOut, p_normalOut, p_collisionSurfaceOut, NULL);
}
bool RayCollision(CSurface3D *p_surfaces, unsigned p_surfaceQty, CModelVertex3D *p_vertices, CVector3D &p_position, CVector3D &p_directionUnit, float &p_collisionDistance, CVector3D &p_collisionPointOut, CSurface3D **p_collisionSurfaceOut);
float Random(void);

#endif