// GameObject.h: interface for the CGameObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAMEOBJECT_H__1634A7FD_5067_48DC_B171_CFE6D9D30083__INCLUDED_)
#define AFX_GAMEOBJECT_H__1634A7FD_5067_48DC_B171_CFE6D9D30083__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\math\Orient3D.h"
#include "..\structs\linkedlist.h"
#include "..\api3d\apitexture.h"
#include "..\api3d\colorrgb.h"


class CGameObject  
{
public:
	CGameObject();
	virtual ~CGameObject();

	unsigned int type;		// What is it?  0 assumes nothing
							// Meaning of #'s predefined by custom app

	COrient3D	orient;			// Current position and orientation
	CVector3D	velocity;		// and velocity

	unsigned int lifeMS;		// Time object exists, if 0 lasts forever

	// Parameters used for rendering
	// Actual use determined by custum types in custom app
	CColorRGB color0;
	CAPITexture *texture0;
	float fParam0;
	float fParam1;

	bool deleted;				// Does this object exist?
};

class CGameObjectListNode : public CLinkedListNode<CGameObject>
{
};

class CGameObjectList : public CLinkedList<CGameObject>
{
public:
	CGameObjectListNode * NewNode(void)
	{
		return (CGameObjectListNode *)(CLinkedList<CGameObject>::NewNode());
	}
	CGameObjectListNode * GetFirst(void)
	{
		return (CGameObjectListNode *)(CLinkedList<CGameObject>::GetFirst());
	}
};

#endif // !defined(AFX_GAMEOBJECT_H__1634A7FD_5067_48DC_B171_CFE6D9D30083__INCLUDED_)
