// DInput.h: interface for the CDInput class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DINPUT_H__8939A9C1_E39C_40E1_B89D_2AFC6CD244F9__INCLUDED_)
#define AFX_DINPUT_H__8939A9C1_E39C_40E1_B89D_2AFC6CD244F9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DIRECTINPUT_VERSION 0x0800
#include <dinput.h>

struct strJoystick
{
	int axis1;
	int axis2;

	bool button1;
	bool button2;
};

// Class Direct input interface for retrieving the various aspects
//  of input (mouse, keyboard, joystick)
class CDInput  
{
public:
	CDInput();
	virtual ~CDInput();
	void Destroy();
	void DestroyJoystick();

	bool InitializeJoystick(HWND p_hWnd);

	void PollJoystick(void);
	void GetJoystickState(strJoystick &p_jsValues);

private:
	static LPDIRECTINPUT8       di8;         
	static LPDIRECTINPUTDEVICE8 diJoystick8;     
    DIJOYSTATE2 joystickState;           // DInput joystick state 

	static BOOL CALLBACK EnumJSObjectsCallback( const DIDEVICEOBJECTINSTANCE* pdidoi,
                                   VOID* pContext );
	static BOOL CALLBACK EnumJoysticksCallback( const DIDEVICEINSTANCE* pdidInstance,
                                     VOID* pContext );
	bool InitializeDInput(void);

	bool valid;	// if this is ever false, dinput8 is no good
};

#endif // !defined(AFX_DINPUT_H__8939A9C1_E39C_40E1_B89D_2AFC6CD244F9__INCLUDED_)
