// PtlFrustum.cpp: implementation of the CPtlFrustum class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PtlFrustum.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPtlFrustum::CPtlFrustum()
{

}

CPtlFrustum::~CPtlFrustum()
{
	planeNormalList.EmptyList();
}

void CPtlFrustum::AddPlaneNormal(CVector3D &p_normal)
{
	CPlaneNormalListNode *node;
	
	node = planeNormalList.NewNode();
	if (node)
	{
		node->SetVec(p_normal);

		// ?? Removing this would make it faster
		// It's here just in case, since not all submissions
		//   are unitized
		node->Unitize();
	}
}

void CPtlFrustum::ReflectOnPlane(CVector3D &p_planePoint, CVector3D &p_planeNormal, CPtlFrustum &p_resultOut)
{
    p_resultOut.Initialize();
    p_resultOut.SetViewpoint(viewpoint + (p_planeNormal * (-2.0f * ((viewpoint - p_planePoint) * (p_planeNormal)))), 
                        forward + (p_planeNormal * (-2.0f * (forward * p_planeNormal))));

	CPlaneNormalListNode *node;
	node = planeNormalList.GetFirst();
	if (node)
	while (node->next != NULL)
	{
		p_resultOut.AddPlaneNormal(*node + (p_planeNormal * (-2.0f * (*node * p_planeNormal))));

		node = (CPlaneNormalListNode *)(node->next);
	}
}

