// PtlFrustum.h: interface for the CPtlFrustum class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PTLFRUSTUM_H__140F6C62_D9C3_4B69_9B91_9394E0C5843F__INCLUDED_)
#define AFX_PTLFRUSTUM_H__140F6C62_D9C3_4B69_9B91_9394E0C5843F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\structs\LinkedList.h"
#include "..\math\Vector3D.h"

class CPlaneNormalListNode: public CLinkedListNode<CVector3D>
{
};

class CPlaneNormalList: public CLinkedList<CVector3D>
{
public:
	CPlaneNormalListNode * NewNode(void)
	{
		return (CPlaneNormalListNode *)CLinkedList<CVector3D>::NewNode();
	}
	CPlaneNormalListNode * GetFirst(void)
	{
		return (CPlaneNormalListNode *)CLinkedList<CVector3D>::GetFirst();
	}
};

class CPtlFrustum  
{
public:
	CPtlFrustum();
	virtual ~CPtlFrustum();

	CVector3D viewpoint;
	CVector3D forward;

	CPlaneNormalList planeNormalList;

	inline CPlaneNormalList & GetPlaneNormalList(void) {return planeNormalList;}
	inline CVector3D & GetViewpoint(void) {return viewpoint;}
	inline CVector3D & GetForward(void) {return forward;}
	inline SetViewpoint(CVector3D &p_viewpoint, CVector3D &p_forward)
	{
		viewpoint = p_viewpoint;
		forward = p_forward;
	}

	void Initialize(void) {planeNormalList.EmptyList();}

	void AddPlaneNormal(CVector3D &p_normal);

	void ReflectOnPlane(CVector3D &p_planePoint, CVector3D &p_planeNormal, CPtlFrustum &p_resultOut);
};

#endif // !defined(AFX_PTLFRUSTUM_H__140F6C62_D9C3_4B69_9B91_9394E0C5843F__INCLUDED_)
