// Vector3D.h: interface for the CVector3D class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VECTOR3D_H__7ECBC5D9_70FC_4387_BDBE_A18DD270B1DF__INCLUDED_)
#define AFX_VECTOR3D_H__7ECBC5D9_70FC_4387_BDBE_A18DD270B1DF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <math.h> // sqr

class CVector3D  
{
public:
	CVector3D();
	CVector3D(float p_x, float p_y, float p_z);
	//virtual ~CVector3D();	// taken out die to Profiling claiming it takes
							//   up 7.6% of the runtime (doubtful)

	float x, y, z;

	// Didn't need this
	//inline CVector3D & operator = (const CVector3D &p_vector)
	//{
	//	x = p_vector.x;
	//	y = p_vector.y;
	//	z = p_vector.z;
		//CopyMemory((void *)&p_vector.x, (void *)&x, 12);	// Would this work?

	//	return *this;
	//}

	CVector3D operator + (const CVector3D &p_vector)
	{
		static CVector3D out;
		out.x = p_vector.x + x;
		out.y = p_vector.y + y;
		out.z = p_vector.z + z;

		return out;
	}

	CVector3D operator - (const CVector3D &p_vector1)
	{
		static CVector3D out;
		out.x = x - p_vector1.x;
		out.y = y - p_vector1.y;
		out.z = z - p_vector1.z;

		return out;
	}

	bool operator == (const CVector3D &p_vector1)
	{
		return ((x==p_vector1.x)&&(y==p_vector1.y)&&(z==p_vector1.z));
	}

	bool operator != (const CVector3D &p_vector1)
	{
		return ((x!=p_vector1.x)||(y!=p_vector1.y)||(z!=p_vector1.z));
	}

	float operator * (const CVector3D &p_vector)
	{
		return (p_vector.x*x + p_vector.y*y + p_vector.z*z);
	}

	static CVector3D ZeroVector(void)
	{
		static CVector3D zero(0,0,0);
		return zero;
	}

	CVector3D operator * (const float p_scalar)
	{
		static CVector3D out;
		out.x = p_scalar * x;
		out.y = p_scalar * y;
		out.z = p_scalar * z;

		return out;
	}
	CVector3D ScmVec(const float p_scalar)
	{
		static CVector3D out;
		out.x = p_scalar * x;
		out.y = p_scalar * y;
		out.z = p_scalar * z;

		return out;
	}

	bool IsEqual(CVector3D &p_vector)
	{
		return((p_vector.x==x) && (p_vector.y==y) && (p_vector.z==z));
	}

	float MgnTud(void)
	{
		return (float(sqrt(x*x + y*y + z*z)));
	}
	float MgnTudSqr(void)
	{
		return (x*x + y*y + z*z);
	}

	inline void SetVec(float p_x, float p_y, float p_z)
	{
		x = p_x;
		y = p_y;
		z = p_z;
	}

	inline void SetVec(CVector3D &p_vector)
	{
		*this = p_vector;
	}

	inline void SetVec(int p_x, int p_y, int p_z)
	{
		x = float(p_x);
		y = float(p_y);
		z = float(p_z);
	}

	CVector3D CrsProd(CVector3D &p_vector);
	bool Unitize(void);

	// Note: This routine requires you to send a local string to
	//    populate, at least 50 characters to be sure
	//    It returns a pointer to the string so you can immediately
	//    use it for output
	char * OutStr(char * p_str)
	{
		sprintf(p_str, "(%g, %g, %g)", x, y, z);
		return p_str;
	}

	static CVector3D Vector3D(float p_x, float p_y, float p_z)
	{
		CVector3D out;
		out.x = p_x;
		out.y = p_y;
		out.z = p_z;

		return out;
	}

	bool SphereCollision(CVector3D &p_pos, CVector3D &p_offset, float p_radius, float &p_timeOut, CVector3D &p_collisionNormalOut);
};

#endif // !defined(AFX_VECTOR3D_H__7ECBC5D9_70FC_4387_BDBE_A18DD270B1DF__INCLUDED_)
