// PixelStorageMgr.cpp: implementation of the CPixelStorageMgr class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PixelStorageMgr.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPixelStorageBlock::CPixelStorageBlock()
{

}

CPixelStorageBlock::~CPixelStorageBlock()
{

}

CLinkedList<CPixelStorageBlock> CLinkedList<CPixelStorageBlock>::DeletedList;

CPixelStorageMgr::CPixelStorageMgr()
{
}

CPixelStorageMgr::~CPixelStorageMgr()
{
}

void CPixelStorageMgr::Initialize(unsigned p_width, unsigned p_height)
{
	blockList.EmptyList();

	CLinkedListNode<CPixelStorageBlock> *node = blockList.NewNode();
	if (node)
	{
		node->width = p_width;
		node->height = p_height;

		totalWidth = p_width;
		totalHeight = p_height;

		node->x = 0;
		node->y = 0;
	}
}

bool CPixelStorageMgr::AllocateBlock(unsigned p_width, unsigned p_height, unsigned &p_xOut, unsigned &p_yOut)
{
	CLinkedListNode<CPixelStorageBlock> *node = blockList.GetFirst();

	if ((p_width == 0) && (p_height == 0)) return false;

	if (node)
	while (node->next != NULL)
	{
		if ((node->width >= p_width) && (node->height >= p_height))
		{
			p_xOut = node->x;
			p_yOut = node->y;

			// Add two blocks to alter the shape of the block we
			//   took a chunk from
			CLinkedListNode<CPixelStorageBlock> *node1;
			if (node->x + p_width < node->width)
			{
				// Chunk to the right of the allocated block
				node1 = blockList.NewNode();
				node1->x = node->x + p_width;
				node1->y = node->y;
				node1->width = node->width - p_width;
				node1->height = p_height;
			}

			// Modify current node to become lower block
			node->y = node->y + p_height;
			node->height = node->height - p_height;

			// We are done unless there is no height left
			if (node->y >= node->height)
			{
				// Get rid of the record for the block we allocated
				blockList.Delete(node);
//				node1 = blockList.NewNode();
//				node1->x = node->x;
//				node1->y = node->y;
//				node1->width = node->width;
//				node1->height = node->height;
			}


			return true;
		}

		node = node->next;
	}

	return false;
}
